import { __assign, __values } from "tslib";
import { rootInjector } from '@stringke/sigi-di';
import { cloneDeepPoj } from './utils';
export var reactive = function (EffectModuleConstructor, componentOptions) {
    var _a, _b;
    var effectModule = rootInjector.getInstance(EffectModuleConstructor);
    var store = effectModule.store;
    var initialState = store.state;
    var statePassToVue = __assign({}, initialState);
    var subscription = store.state$.subscribe(function (state) {
        Object.assign(statePassToVue, state);
    });
    var actionsCreator = effectModule.getActions();
    var dispatchProps = Object.keys(actionsCreator).reduce(function (acc, cur) {
        acc[cur] = function (payload) {
            var action = actionsCreator[cur](payload);
            store.dispatch(action);
        };
        return acc;
    }, Object.create(null));
    var originalBeforeDestroy = componentOptions.beforeDestroy;
    componentOptions.beforeDestroy = function beforeDestroy() {
        subscription.unsubscribe();
        typeof originalBeforeDestroy === 'function' ? originalBeforeDestroy.call(this) : void 0;
    };
    componentOptions.methods = Object.assign(dispatchProps, (_a = componentOptions.methods) !== null && _a !== void 0 ? _a : {});
    var originalData = componentOptions.data;
    componentOptions.data = function data() {
        if (typeof originalData === 'function') {
            return Object.assign(statePassToVue, originalData.call(this));
        }
        return statePassToVue;
    };
    var syncToSigi = (_b = componentOptions.syncToSigi) !== null && _b !== void 0 ? _b : [];
    var originalBeforeUpdate = componentOptions.beforeUpdate;
    componentOptions.beforeUpdate = function beforeUpdate() {
        var e_1, _a, _b;
        var latestState = store.state;
        var changed = false;
        try {
            for (var syncToSigi_1 = __values(syncToSigi), syncToSigi_1_1 = syncToSigi_1.next(); !syncToSigi_1_1.done; syncToSigi_1_1 = syncToSigi_1.next()) {
                var prop = syncToSigi_1_1.value;
                if (!(prop in statePassToVue) && process.env.NODE_ENV === 'development') {
                    console.warn(prop + " in syncToSigi option is not existed in defaultProps property in Sigi module");
                }
                var propValue = this[prop];
                if (propValue !== latestState[prop]) {
                    latestState = __assign(__assign({}, latestState), (_b = {}, _b[prop] = cloneDeepPoj(propValue), _b));
                    changed = true;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (syncToSigi_1_1 && !syncToSigi_1_1.done && (_a = syncToSigi_1.return)) _a.call(syncToSigi_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (changed) {
            store.state$.next(latestState);
        }
        if (typeof originalBeforeUpdate === 'function') {
            originalBeforeUpdate.call(this);
        }
    };
    return componentOptions;
};
