import { __read, __values } from "tslib";
export var MAX_OBJECT_DEPTH = 100;
export var CloneTrait = Symbol('clone-trait');
export function cloneDeepPoj(target) {
    var depth = 0;
    function _clone(obj) {
        var e_1, _a;
        if (depth >= MAX_OBJECT_DEPTH) {
            throw new TypeError('Max clone depth reached');
        }
        depth++;
        if (typeof obj === 'object') {
            if (obj[CloneTrait]) {
                return obj[CloneTrait]();
            }
            if (Array.isArray(obj)) {
                return obj.map(function (item) { return cloneDeepPoj(item); });
            }
            if (!isPlainObject(obj)) {
                throw new TypeError('Only plain object supported to sync to Sigi');
            }
            var result = Object.create(null);
            try {
                for (var _b = __values(Object.entries(obj)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
                    result[key] = _clone(value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return result;
        }
        if (typeof obj === 'function' || typeof obj === 'symbol') {
            throw new TypeError(typeof obj + " type could not be cloned");
        }
        return obj;
    }
    return _clone(target);
}
function isPlainObject(obj) {
    return Object.prototype.toString.call(obj) === '[object Object]';
}
